Index: /trunk/Makefile
===================================================================
--- /trunk/Makefile	(revision 656)
+++ /trunk/Makefile	(revision 657)
@@ -130,5 +130,5 @@
 	rm -f $(DISK_IMAGE)
 	./create_dmg  	create $(basename $(DISK_IMAGE))
-	dd              if=$(DISK_IMAGE) of=temp.dmg count=65536
+	dd              if=$(DISK_IMAGE) of=temp.dmg count=131072
 	mv              temp.dmg $(DISK_IMAGE)
 	mmd             -o -i $(DISK_IMAGE) ::/bin                            || true
@@ -139,5 +139,5 @@
 	mcopy           -o -i $(DISK_IMAGE) images/lena_256.raw ::/misc       || true             
 	mcopy           -o -i $(DISK_IMAGE) images/images_128.raw ::/misc     || true             
-	mcopy           -o -i $(DISK_IMAGE) images/philips_1024_2.raw ::/misc || true             
+	mcopy           -o -i $(DISK_IMAGE) images/philips_1024.raw ::/misc   || true             
 	mcopy           -o -i $(DISK_IMAGE) images/couple_512.raw ::/misc     || true             
 	mcopy           -o -i $(DISK_IMAGE) images/wood_32.raw ::/misc        || true             
Index: /trunk/hal/generic/hal_atomic.h
===================================================================
--- /trunk/hal/generic/hal_atomic.h	(revision 656)
+++ /trunk/hal/generic/hal_atomic.h	(revision 657)
@@ -2,5 +2,5 @@
  * hal_atomic.h - Generic Atomic Operations API definition.
  *
- * Authors   Alain Greiner    (2016)
+ * Authors   Alain Greiner    (2016,2017,2018,2019,2020)
  *
  * Copyright (c)  UPMC Sorbonne Universites
Index: /trunk/hal/generic/hal_remote.h
===================================================================
--- /trunk/hal/generic/hal_remote.h	(revision 656)
+++ /trunk/hal/generic/hal_remote.h	(revision 657)
@@ -2,5 +2,5 @@
  * hal_remote.h - Generic Remote Access API definition.
  *
- * Authors    Alain Greiner (2016,2017,2018,2019)
+ * Authors    Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c)  UPMC Sorbonne Universites
Index: /trunk/hal/generic/hal_uspace.h
===================================================================
--- /trunk/hal/generic/hal_uspace.h	(revision 656)
+++ /trunk/hal/generic/hal_uspace.h	(revision 657)
@@ -2,5 +2,5 @@
  * hal_uspace.h - Generic User Space Access API definition
  *
- * Authors    Alain Greiner (2016,2017,2018,2019)
+ * Authors    Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c)  UPMC Sorbonne Universites
Index: /trunk/hal/tsar_mips32/core/hal_macros.h
===================================================================
--- /trunk/hal/tsar_mips32/core/hal_macros.h	(revision 656)
+++ /trunk/hal/tsar_mips32/core/hal_macros.h	(revision 657)
@@ -26,5 +26,5 @@
 
 //////////////////////////////////////////////////////////////////////////////////////////
-//     User-side, hardware dependant, macros definition.
+//   Hardware dependant, macros definition.
 //
 //   Any architecture specific implementation must implement these macros.
Index: /trunk/hal/tsar_mips32/core/hal_remote.c
===================================================================
--- /trunk/hal/tsar_mips32/core/hal_remote.c	(revision 656)
+++ /trunk/hal/tsar_mips32/core/hal_remote.c	(revision 657)
@@ -3,5 +3,5 @@
  * 
  * Authors : Mohammed Karaoui (2015)
- *           Alain Greiner    (2016)
+ *           Alain Greiner    (2016,2017,2018,2019)
  *
  * Copyright (c) UPMC Sorbonne Universites
Index: /trunk/hal/tsar_mips32/core/hal_uspace.c
===================================================================
--- /trunk/hal/tsar_mips32/core/hal_uspace.c	(revision 656)
+++ /trunk/hal/tsar_mips32/core/hal_uspace.c	(revision 657)
@@ -2,5 +2,5 @@
  * hal_uspace.c - implementation of Generic User Space Access API for MIPS32
  * 
- * Author        Alain Greiner   (2016,2017,2018,2019)
+ * Author        Alain Greiner   (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -54,5 +54,4 @@
     uint32_t dst = (uint32_t)GET_PTR( k_dst_xp );
     uint32_t cxy = (uint32_t)GET_CXY( k_dst_xp );
-    
  
 #if DEBUG_HAL_USPACE
Index: /trunk/hal/tsar_mips32/drivers/soclib_bdv.c
===================================================================
--- /trunk/hal/tsar_mips32/drivers/soclib_bdv.c	(revision 656)
+++ /trunk/hal/tsar_mips32/drivers/soclib_bdv.c	(revision 657)
@@ -2,5 +2,5 @@
  * soclib_bdv.c - soclib simple block device driver implementation.
  *
- * Author     Alain Greiner (2016,2017,2018)
+ * Author     Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
Index: /trunk/hal/tsar_mips32/drivers/soclib_dma.c
===================================================================
--- /trunk/hal/tsar_mips32/drivers/soclib_dma.c	(revision 656)
+++ /trunk/hal/tsar_mips32/drivers/soclib_dma.c	(revision 657)
@@ -2,5 +2,5 @@
  * soclib_dma.c - soclib Multi Channels DMA driver implementation
  *
- * Author     Alain Greiner (2017)
+ * Author     Alain Greiner (2017,2018,2019,2020)
 
  * Copyright (c) UPMC Sorbonne Universites
@@ -39,6 +39,6 @@
     chdev->isr = &soclib_dma_isr;
 
-    // enable interrupts
-	hal_remote_s32( XPTR( dma_cxy , dma_ptr + DMA_IRQ_DISABLED ) , 0 );
+    // disable interrupts
+	hal_remote_s32( XPTR( dma_cxy , dma_ptr + DMA_IRQ_DISABLED ) , 1 );
 
 } // soclib_dma_init()
@@ -47,18 +47,32 @@
 void __attribute__ ((noinline)) soclib_dma_cmd( xptr_t thread_xp )
 {
+    bool_t     sync;
     xptr_t     dev_xp;       // extended pointer on DMA devive
     xptr_t     dst_xp;       // extended pointer on destination buffer
     xptr_t     src_xp;       // extended pointer on source buffer
     uint32_t   size;         // buffer size
+    uint32_t   status;       // DMA status
 
     // get client thread cluster and local pointer
-    cxy_t      thread_cxy = GET_CXY( thread_xp );
-    thread_t * thread_ptr = (thread_t *)GET_PTR( thread_xp );
-
-    // get command arguments and extended pointer on DMA device
-    dev_xp = (xptr_t)hal_remote_l64( XPTR( thread_cxy , &thread_ptr->dma_cmd.dev_xp ) );
-    dst_xp = (xptr_t)hal_remote_l64( XPTR( thread_cxy , &thread_ptr->dma_cmd.dst_xp ) );
-    src_xp = (xptr_t)hal_remote_l64( XPTR( thread_cxy , &thread_ptr->dma_cmd.src_xp ) );
-    size   =         hal_remote_l32 ( XPTR( thread_cxy , &thread_ptr->dma_cmd.size   ) );
+    cxy_t      client_cxy = GET_CXY( thread_xp );
+    thread_t * client_ptr = (thread_t *)GET_PTR( thread_xp );
+
+#if (DEBUG_HAL_IOC_RX || DEBUG_HAL_IOC_TX)
+uint32_t    cycle        = (uint32_t)hal_get_cycles();
+thread_t  * this         = CURRENT_THREAD;
+process_t * process      = hal_remote_lpt( XPTR( th_cxy , &th_ptr->process ) );
+pid_t       client_pid   = hal_remote_l32( XPTR( th_cxy , &process->pid ) );
+trdid_t     client_trdid = hal_remote_l32( XPTR( th_cxy , &th_ptr->trdid ) );
+#endif 
+
+// TODO both the client and the server threads are allways local,
+// we could replace all these remote accesses by local accesses !!!  [AG]
+
+    // get command arguments and extended pointer on DMA device descriptor
+    sync   =         hal_remote_l32( XPTR( client_cxy , &client_ptr->dma_cmd.sync   ) );
+    dev_xp = (xptr_t)hal_remote_l64( XPTR( client_cxy , &client_ptr->dma_cmd.dev_xp ) );
+    dst_xp = (xptr_t)hal_remote_l64( XPTR( client_cxy , &client_ptr->dma_cmd.dst_xp ) );
+    src_xp = (xptr_t)hal_remote_l64( XPTR( client_cxy , &client_ptr->dma_cmd.src_xp ) );
+    size   =         hal_remote_l32( XPTR( client_cxy , &client_ptr->dma_cmd.size   ) );
 
     // get DMA device cluster and local pointer
@@ -66,10 +80,8 @@
     chdev_t * dev_ptr = (chdev_t *)GET_PTR( dev_xp );
 
-    // get extended pointer on SOCLIB-DMA peripheral
-    xptr_t     dma_xp = hal_remote_l32( XPTR( dev_cxy , &dev_ptr->base ) );
-
-    // get SOCLIB_DMA device cluster and local pointer
+    // get pointers on DMA peripheral
+    xptr_t     dma_xp  = hal_remote_l32( XPTR( dev_cxy , &dev_ptr->base ) );
     cxy_t      dma_cxy = GET_CXY( dma_xp );
-    uint32_t * dma_ptr = (uint32_t *)GET_PTR( dma_xp );
+    uint32_t * dma_ptr = GET_PTR( dma_xp );
 
     // get DMA channel index and channel base address
@@ -82,15 +94,84 @@
     uint32_t   src_msb = (uint32_t)(src_xp>>32);
 
-    // set SOCLIB_DMA registers to start tranfer operation
+    // set SOCLIB_DMA registers and launch tranfer operation
     hal_remote_s32( XPTR( dma_cxy , base + DMA_SRC     ) , src_lsb ); 
     hal_remote_s32( XPTR( dma_cxy , base + DMA_SRC_EXT ) , src_msb ); 
     hal_remote_s32( XPTR( dma_cxy , base + DMA_DST     ) , dst_lsb );
     hal_remote_s32( XPTR( dma_cxy , base + DMA_DST_EXT ) , dst_msb );
-    hal_remote_s32( XPTR( dma_cxy , base + DMA_LEN     ) , size    );
-
-    // Block and deschedule server thread
-    thread_block( XPTR( local_cxy , CURRENT_THREAD ) , THREAD_BLOCKED_ISR );
-    sched_yield("blocked on ISR");
-    
+    hal_remote_s32( XPTR( dma_cxy , base + DMA_LEN_STS ) , size    );
+
+ #if DEBUG_HAL_DMA
+if( DEBUG_HAL_DMA < cycle )
+printk("\n[%s] thread[%x,%x] launched DMA for client thread[%x,%x] / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, client_pid, client_trdid, cycle );
+#endif
+
+    // waiting policy  depends on the command type
+    // - for an asynchronous command, this function is called by the server thread
+    //   => block and deschedule after launching the transfer. 
+    //   The operation status is reported in the command by the ISR, and the
+    //   server thread is re-activated by the ISR.
+    // - for a synchronous command, this function is called by the client thread
+    //   => mask the DMA_IRQ and poll the DMA status register until transfer completion,
+    //   and reports status in the command when the transfer is completed.
+
+    if( sync )                            // client thread poll status until completion
+    {
+        while( 1 )
+        {
+            status = hal_remote_l32( XPTR( dma_cxy , base + DMA_LEN_STS ) );
+
+            if( (status == DMA_SUCCESS) || (status == DMA_IDLE) )
+            {
+                // set operation status in command
+                hal_remote_s32( XPTR( client_cxy , &client_ptr->dma_cmd.error ) , 0 );
+
+#if DEBUG_HAL_DMA
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_HAL_DMA < cycle )
+printk("\n[%s] thread[%x,%x] exit after SYNC success / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, cycle );
+#endif
+                // exit while
+                break;
+            }
+            else if( (status == DMA_ERROR_READ) || (status == DMA_ERROR_WRITE) )
+            {
+                // set operation status in command
+                hal_remote_s32( XPTR( client_cxy , &client_ptr->dma_cmd.error ) , 1 );
+
+#if DEBUG_HAL_DMA
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_HAL_DMA < cycle )
+printk("\n[%s] thread[%x,%x] exit after SYNC failure / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, cycle );
+#endif
+                // exit while
+                break;
+            }
+        }
+    }    
+    else                                // server thread block and deschedule
+    {
+        // server thread blocks on ISR
+        thread_block( XPTR( local_cxy , CURRENT_THREAD ) , THREAD_BLOCKED_ISR );
+
+        // enable DMA interrupts
+	    hal_remote_s32( XPTR( dma_cxy , dma_ptr + DMA_IRQ_DISABLED ) , 0 );
+
+        // server thread deschedules
+        sched_yield("blocked on ISR");
+
+        // disable DMA interrupts
+	    hal_remote_s32( XPTR( dma_cxy , dma_ptr + DMA_IRQ_DISABLED ) , 1 );
+
+#if DEBUG_HAL_DMA
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_HAL_DMA < cycle )
+printk("\n[%s] thread[%x,%x] exit after ASYNC / client thread[%x,%x] / cycle %d\n",
+__FUNCTION__ , this->process->pid, this->trdid, client_pid, client_trdid, cycle );
+#endif
+
+    }
 } // soclib_dma_cmd()
 
@@ -98,10 +179,10 @@
 void __attribute__ ((noinline)) soclib_dma_isr( chdev_t * chdev )
 {
-    // get extended pointer on client thread
+    // get extended pointer on server thread
+    xptr_t server_xp = XPTR( local_cxy , &chdev->server );
+
+   // get extended pointer on client thread
     xptr_t root      = XPTR( local_cxy , &chdev->wait_root );
     xptr_t client_xp = XLIST_FIRST( root , thread_t , wait_list );
-
-    // get extended pointer on server thread
-    xptr_t server_xp = XPTR( local_cxy , &chdev->server );
 
     // get client thread cluster and local pointer
@@ -113,9 +194,9 @@
     uint32_t * dma_ptr  = (uint32_t *)GET_PTR( chdev->base );
 
-    // get DMA channel base address
+    // build DMA channel base address
     uint32_t * base = dma_ptr + (DMA_SPAN * chdev->channel);
 
     // get DMA status register 
-	uint32_t status = hal_remote_l32( XPTR( dma_cxy , base + DMA_LEN ) );   
+	uint32_t status = hal_remote_l32( XPTR( dma_cxy , base + DMA_LEN_STS ) );   
 
     // acknowledge IRQ
@@ -129,7 +210,4 @@
     thread_unblock( server_xp , THREAD_BLOCKED_ISR );
 
-    // unblock client thread
-    thread_unblock( client_xp , THREAD_BLOCKED_IO );
-
 } // soclib_dma_isr()
 
Index: /trunk/hal/tsar_mips32/drivers/soclib_dma.h
===================================================================
--- /trunk/hal/tsar_mips32/drivers/soclib_dma.h	(revision 656)
+++ /trunk/hal/tsar_mips32/drivers/soclib_dma.h	(revision 657)
@@ -39,5 +39,5 @@
     DMA_SRC		     = 0,    /*! source buffer 32 LSB address bits                         */
     DMA_DST		     = 1,    /*! source buffer 32 LSB address bits                         */
-    DMA_LEN		     = 2,    /*! number of bytes (on write) / transfer status (on read)    */
+    DMA_LEN_STS	     = 2,    /*! number of bytes (on write) / transfer status (on read)    */
     DMA_RESET		 = 3,    /*! desactivate channel (can be usde to acknowledge IRQ)      */
     DMA_IRQ_DISABLED = 4,    /*! no IRQ generated if non zero                              */
@@ -60,5 +60,6 @@
 
 /********************************************************************************************
- * This function access the SOCLIB_DMA hardware register to enable interrupts.
+ * This function access the SOCLIB_DMA hardware register to disable interrupts,
+ * because the most frequent operations are supposed to be synchronous accesses.
  ********************************************************************************************
  * @ chdev     : pointer on DMA chdev descriptor.
@@ -67,10 +68,13 @@
 
 /********************************************************************************************
- * This function is called by the server thread associated to the DMA device.
- * It access the command embedded in the calling thread descriptor, (format defined in the 
- * dev_dma.h file) and access the SOCLIB_DMA hardware registers to start command execution.
- * Then it blocks on the THREAD_BLOCKED_DEV_ISR and deschedules, because each DMA channel 
- * can only execute one command at a given time. 
- * It is re-activated by the ISR signaling the transfer completion.
+ * This function can be called by the "server" thread associated to the DMA channel, for an
+ * asynchronous access, or can be directly called by the "client" thread for a synchronous
+ * access. In both cases, it get the command arguments from the calling thread descriptor,
+ * and access the DMA registers to launch the DMA transfer. 
+ * Then, the waiting policy depends on the command type:
+ * - for asynchronous access, it enables the DMA interrupts, blocks on THREAD_BLOCKED_ISR,
+ *   and deschedules. It will be re-activated by the soclib_dma_isr() function.
+ * - for a synchronous transfer, it polls the DMA status register until completion,
+ *   and reports the transfer status in the command registered in the client thread.  
  ********************************************************************************************
  * @ thread_xp  : extended pointer on the client thread.
@@ -80,7 +84,7 @@
 /********************************************************************************************
  * This Interrupt Service Routine is executed when the IRQ signaling the completion of 
- * a DMA command is received by a core. It acknowledge the IRQ by accessing the proper
- * SOCLIB_DMA register, unblock the client thread, and unblock the server thread that
- * can starts execution of a new command if the waiting queue is not emppty.
+ * an asynchronous DMA command is received by a core. It acknowledge the IRQ by accessing
+ * the proper SOCLIB_DMA register, reports the transfer status in the command registered
+ * in the client thread descriptor, and unblock the server thread.
  ********************************************************************************************
  * @ chdev     : pointer on DMA chdev descriptor.
Index: /trunk/hal/tsar_mips32/drivers/soclib_fbf.c
===================================================================
--- /trunk/hal/tsar_mips32/drivers/soclib_fbf.c	(revision 656)
+++ /trunk/hal/tsar_mips32/drivers/soclib_fbf.c	(revision 657)
@@ -2,5 +2,5 @@
  * soclib_fbf.c - soclib frame-buffer driver implementation.
  *
- * Author Alain greiner (2016,2017,2018,2019)
+ * Author Alain greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -59,10 +59,10 @@
 void __attribute__((noinline)) soclib_fbf_cmd( xptr_t thread_xp )
 {
-    uint32_t   cmd_type;    // READ / WRITE / SYNC_READ / SYNC_WRITE
-    uint32_t   offset;
-    uint32_t   length;
-    void     * buffer;      // pointer on memory buffer in user space
-    xptr_t     fbf_xp;
+    uint32_t   type;        // USER_WRITE / USER_READ / KERNEL_WRITE / KERNEL_READ
+    uint32_t   offset;      // offset in FBF (in pixels)
+    uint32_t   npixels;     // number of pixels to move
+    xptr_t     fbf_xp;      // extended pointer on FBF chdev descriptor
     uint32_t   status;      // I/0 operation status (from BDV)
+    void     * buffer;      // pointer on kernel or user buffer 
 
     // get client thread cluster and local pointer
@@ -78,9 +78,9 @@
 
     // get command arguments
-    cmd_type =         hal_remote_l32( XPTR( th_cxy , &th_ptr->fbf_cmd.type   ) );
-    offset   =         hal_remote_l32( XPTR( th_cxy , &th_ptr->fbf_cmd.offset ) );
-    length   =         hal_remote_l32( XPTR( th_cxy , &th_ptr->fbf_cmd.length ) );
-    buffer   =         hal_remote_lpt( XPTR( th_cxy , &th_ptr->fbf_cmd.buffer ) );
-    fbf_xp   = (xptr_t)hal_remote_l64( XPTR( th_cxy , &th_ptr->fbf_cmd.dev_xp ) );
+    type     = hal_remote_l32( XPTR( th_cxy , &th_ptr->fbf_cmd.type    ) );
+    offset   = hal_remote_l32( XPTR( th_cxy , &th_ptr->fbf_cmd.offset  ) );
+    npixels  = hal_remote_l32( XPTR( th_cxy , &th_ptr->fbf_cmd.npixels ) );
+    fbf_xp   = hal_remote_l64( XPTR( th_cxy , &th_ptr->fbf_cmd.dev_xp  ) );
+    buffer   = hal_remote_lpt( XPTR( th_cxy , &th_ptr->fbf_cmd.buffer  ) );
 
     // get cluster and local pointer on FBF chdev
@@ -92,45 +92,61 @@
 
     // execute command
-    if( cmd_type == FBF_READ )     // use a (kernel -> user) memcpy
+    if( type == FBF_DRIVER_USER_WRITE )     // user_buffer => FBF 
     {
 
 #if DEBUG_HAL_FBF 
 if( DEBUG_HAL_FBF < cycle )
-printk("\n[%s] client thread[%x,%x] / READ / offset %d / length %d / buffer %x / fbf (%x,%x)\n",
-__FUNCTION__ , client_pid, client_trdid,
-offset, length, buffer, GET_CXY(base_xp), GET_PTR(base_xp) );
+printk("\n[%s] client thread[%x,%x] / USER_WRITE / offset %d / npixels %d / buf %x\n",
+__FUNCTION__ , client_pid, client_trdid, offset, npixels, buffer );
 #endif
-        hal_copy_to_uspace( buffer,
-                            base_xp + offset,
-                            length );
-#if DEBUG_HAL_FBF 
-if( DEBUG_HAL_FBF < cycle )
-printk("\n[%s] client thread[%x,%x] / READ successful / cycle %d\n",
-__FUNCTION__ , client_pid, client_trdid , cycle );
-#endif
-
+        hal_copy_from_uspace( base_xp + offset,
+                              buffer,
+                              npixels );
     }
-    else  // cmd_type == FBF_WRITE => use a (user -> kernel)  memcpy
+    else if( type == FBF_DRIVER_USER_READ )  // FBF => user_buffer
     {
 
 #if DEBUG_HAL_FBF 
 if( DEBUG_HAL_FBF < cycle )
-printk("\n[%s] client thread[%x,%x] / WRITE / offset %d / length %d / buffer %x / fbf (%x,%x)\n",
-__FUNCTION__ , client_pid, client_trdid, 
-offset, length, buffer, GET_CXY(base_xp), GET_PTR(base_xp) );
+printk("\n[%s] client thread[%x,%x] / USER_READ / offset %d / npixels %d / buf %x\n",
+__FUNCTION__ , client_pid, client_trdid, offset, npixels, buffer );
 #endif
-        hal_copy_from_uspace( base_xp + offset,
-                              buffer,
-                              length );
+        hal_copy_to_uspace( buffer,
+                            base_xp + offset,
+                            npixels );
+    }
+    else if( type == FBF_DRIVER_KERNEL_WRITE )  // kernel_buffer => FBF
+    {
+
 #if DEBUG_HAL_FBF 
 if( DEBUG_HAL_FBF < cycle )
-printk("\n[%s] client thread[%x,%x] / WRITE successful / cycle %d\n",
-__FUNCTION__ , client_pid, client_trdid , cycle );
+printk("\n[%s] client thread[%x,%x] / KERNEL_WRITE / offset %d / npixels %d / buf %x\n",
+__FUNCTION__ , client_pid, client_trdid, offset, npixels, buffer );
 #endif
+        hal_remote_memcpy( base_xp + offset,
+                           XPTR( local_cxy , buffer ),
+                           npixels );
+    }
+    else if( type == FBF_DRIVER_KERNEL_READ )  // FBF => kernel_buffer
+    {
 
+#if DEBUG_HAL_FBF 
+if( DEBUG_HAL_FBF < cycle )
+printk("\n[%s] client thread[%x,%x] / KERNEL_READ / offset %d / npixels %d / buf %x\n",
+__FUNCTION__ , client_pid, client_trdid, offset, npixels, buffer );
+#endif
+        hal_remote_memcpy( XPTR( local_cxy , buffer ),
+                           base_xp + offset,
+                           npixels );
     }
 
     // set success in command
     hal_remote_s32( XPTR( th_cxy , &th_ptr->fbf_cmd.error ) , 0 );
+
+#if DEBUG_HAL_FBF 
+if( DEBUG_HAL_FBF < cycle )
+printk("\n[%s] client thread[%x,%x] / successful move / cycle %d\n",
+__FUNCTION__ , client_pid, client_trdid , cycle );
+#endif
             
 }  // end soclib_fbf_cmd()
Index: /trunk/hal/tsar_mips32/drivers/soclib_mmc.c
===================================================================
--- /trunk/hal/tsar_mips32/drivers/soclib_mmc.c	(revision 656)
+++ /trunk/hal/tsar_mips32/drivers/soclib_mmc.c	(revision 657)
@@ -2,5 +2,5 @@
  * soclib_mmc.c - soclib L2 cache driver implementation.
  *
- * Author     Alain Greiner (2016,2017,2018,2019)
+ * Author     Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -18,8 +18,7 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH.; if not, write to the Free Software Foundation,
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
-
 
 #include <hal_kernel_types.h>
@@ -29,5 +28,4 @@
 #include <thread.h>
 #include <printk.h>
-
 
 ///////////////////////////////////////
@@ -44,5 +42,4 @@
     *(base + (SOCLIB_MMC_ERROR_FUNC << 7) + SOCLIB_MMC_ERROR_IRQ_ENABLE) = 1;
 } 
-
 
 //////////////////////////////////////////////////////////////
@@ -85,25 +82,44 @@
 
         // set SOCLIB_MMC registers to start INVAL/SYNC operation
-        hal_remote_s32( XPTR( seg_cxy , seg_ptr + SOCLIB_MMC_ADDR_LO    ) , (uint32_t)buf_ptr );
-        hal_remote_s32( XPTR( seg_cxy , seg_ptr + SOCLIB_MMC_ADDR_HI    ) , (uint32_t)dev_cxy );
-        hal_remote_s32( XPTR( seg_cxy , seg_ptr + SOCLIB_MMC_BUF_LENGTH ) , buf_size ); 
-        hal_remote_s32( XPTR( seg_cxy , seg_ptr + SOCLIB_MMC_CMD_TYPE   ) , cc_cmd ); 
+        hal_remote_s32( XPTR( seg_cxy , seg_ptr +
+        MMC_REG( SOCLIB_MMC_CC_FUNC , SOCLIB_MMC_ADDR_LO) ) , (uint32_t)buf_ptr );
+
+        hal_remote_s32( XPTR( seg_cxy , seg_ptr +
+        MMC_REG( SOCLIB_MMC_CC_FUNC , SOCLIB_MMC_ADDR_HI) ) , dev_cxy );
+
+        hal_remote_s32( XPTR( seg_cxy , seg_ptr +
+        MMC_REG( SOCLIB_MMC_CC_FUNC , SOCLIB_MMC_BUF_LENGTH) ) , buf_size );
+
+        hal_remote_s32( XPTR( seg_cxy , seg_ptr +
+        MMC_REG( SOCLIB_MMC_CC_FUNC , SOCLIB_MMC_CMD_TYPE) ) , cc_cmd );
     }
-    else  // (type == MMC_GET_ERROR) or (type == MMC_GET_ERROR) pr (type == MMC_GET_INSTRU )
+    else if( (type == MMC_ERROR_GET) || (type == MMC_ERROR_SET) )
     {
         // get src/dst buffer local pointer and register index
         reg_ptr   = (uint32_t *)hal_remote_lpt( XPTR( th_cxy , &th_ptr->mmc_cmd.reg_ptr ) );
-        reg_index = hal_remote_l32( XPTR( th_cxy , &th_ptr->mmc_cmd.reg_index ) );
+        reg_index =             hal_remote_l32( XPTR( th_cxy , &th_ptr->mmc_cmd.reg_index ) );
 
-        // move register to/from local buffer 
-        if( (type == MMC_GET_ERROR) || (type == MMC_GET_INSTRU) )
-        {
-            *reg_ptr =  hal_remote_l32( XPTR( seg_cxy , seg_ptr + reg_index ) );
-        }
-        else  // type == MMC_SET_ERROR
-        {
-            hal_remote_s32( XPTR( seg_cxy , seg_ptr + reg_index ) , *reg_ptr );
-        }
+        // build extended pointer on relevant MMC register
+        xptr_t mmc_reg_xp = XPTR( seg_cxy , seg_ptr +
+                                  MMC_REG( SOCLIB_MMC_ERROR_FUNC , reg_index ) );
+
+        // move MMC register to/from local buffer 
+        if( type == MMC_ERROR_GET ) *reg_ptr = hal_remote_l32( mmc_reg_xp );
+        else                        hal_remote_s32( mmc_reg_xp , *reg_ptr );
     }
+    else  // type == MMC_INSTRU_GET
+    {
+        // get dst buffer local pointer and register index
+        reg_ptr   = (uint32_t *)hal_remote_lpt( XPTR( th_cxy , &th_ptr->mmc_cmd.reg_ptr ) );
+        reg_index =             hal_remote_l32( XPTR( th_cxy , &th_ptr->mmc_cmd.reg_index ) );
+
+        // build extended pointer on relevant MMC register
+        xptr_t mmc_reg_xp = XPTR( seg_cxy , seg_ptr +
+                                  MMC_REG( SOCLIB_MMC_INSTR_FUNC , reg_index ) );
+
+        // move MMC register to local buffer  
+        *reg_ptr = hal_remote_l32( mmc_reg_xp );
+    }
+
 } // end soclib_mmc_cmd()
 
@@ -121,6 +137,6 @@
 
     // print an error message on kernel terminal 
-    printk("\n[ERROR] reported from MMC : cxy %x / cycle %d / bad address [%x,%x] / srcid %x\n",
-    local_cxy , (uint32_t)hal_get_cycles() , paddr_hi , paddr_lo , srcid );
+    printk("\n[ERROR] reported from MMC : bad address [%x,%x] / srcid %x / cycle %d\n",
+    paddr_hi , paddr_lo , srcid , (uint32_t)hal_get_cycles() );
 
     // reset MMC IRQ
@@ -128,5 +144,2 @@
     
 } // end soclib_mmc_isr()
-
-
-
Index: /trunk/hal/tsar_mips32/drivers/soclib_mmc.h
===================================================================
--- /trunk/hal/tsar_mips32/drivers/soclib_mmc.h	(revision 656)
+++ /trunk/hal/tsar_mips32/drivers/soclib_mmc.h	(revision 657)
@@ -2,5 +2,5 @@
  * soclib_mmc.h - TSAR L2 cache driver definition.
  *
- * Author    Alain Greiner (2016,2017,2018,2019)
+ * Author    Alain Greiner (2016,2017,2018,2019),2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -49,4 +49,12 @@
 };
 
+enum SoclibMemCacheConfigCmd
+{
+    SOCLIB_MMC_CC_NOP     = 0,
+    SOCLIB_MMC_CC_INVAL   = 1,
+    SOCLIB_MMC_CC_SYNC    = 2,
+};
+
+// CONFIG Registers indexes
 enum SoclibMemCacheCCRegs
 {
@@ -57,11 +65,5 @@
 };
 
-enum SoclibMemCacheConfigCmd
-{
-    SOCLIB_MMC_CC_NOP     = 0,
-    SOCLIB_MMC_CC_INVAL   = 1,
-    SOCLIB_MMC_CC_SYNC    = 2,
-};
-
+// INSTRU Registers indexes
 enum SoclibMemCacheInstrRegs 
 {
@@ -143,4 +145,5 @@
 };
 
+// ERROR registers indexes
 enum SoclibMemCacheRerrorRegs
 {
@@ -157,6 +160,6 @@
 
 /********************************************************************************************
- * This function initializes the SOCLIB_MMC peripheral hardware registers related
- * to error signaling. It enables the MMC peripheral IRQ.
+ * This function initializes the SOCLIB_MMC peripheral hardware registers.
+ * It enables the MMC peripheral IRQ.
  ********************************************************************************************
  * @ chdev      : local pointer on the MMC chdev descriptor.
@@ -175,5 +178,5 @@
 /********************************************************************************************
  * This Interrupt Service Routine is executed when the MMC IRQ signals a faulty address.
- * The ISR should access the vci_mem_cache component to get the faulty physical address 
+ * The ISR should access the relevant MMC register to get the faulty physical address 
  * and the associated SRCID, and acknowledges the IRQ.
  ********************************************************************************************
Index: /trunk/hal/tsar_mips32/drivers/soclib_nic.c
===================================================================
--- /trunk/hal/tsar_mips32/drivers/soclib_nic.c	(revision 656)
+++ /trunk/hal/tsar_mips32/drivers/soclib_nic.c	(revision 657)
@@ -2,5 +2,5 @@
  * soclib_nic.c - SOCLIB_NIC (Network Interface Controler) driver implementation.
  *
- * Author     Alain Greiner (2016,2017,2018,2019)
+ * Author     Alain Greiner (2016,2017,2018,2019,2020:)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -93,5 +93,5 @@
 void __attribute__ ((noinline)) soclib_nic_cmd( xptr_t thread_xp )
 {
-    uint32_t       cmd;          // command type    
+    uint32_t       type;         // command type    
     char         * buffer;       // pointer on command buffer   
     uint32_t       length;       // Ethernet packet length
@@ -109,5 +109,5 @@
 
     // get command arguments
-    cmd    = thread_ptr->nic_cmd.cmd;
+    type   = thread_ptr->nic_cmd.type;
     buffer = thread_ptr->nic_cmd.buffer;
     length = thread_ptr->nic_cmd.length;
@@ -121,5 +121,5 @@
 
     // analyse command type
-    switch( cmd )
+    switch( type )
     {
         /////////////////////////////////////////////////////////////////////////////
@@ -274,5 +274,5 @@
         break;  // end READABLE
         default: {
-            assert( false, "Unknown command <%x>\n", cmd );
+            assert( false, "Unknown command <%x>\n", type );
         }
     }
Index: /trunk/kernel/Makefile
===================================================================
--- /trunk/kernel/Makefile	(revision 656)
+++ /trunk/kernel/Makefile	(revision 657)
@@ -83,4 +83,5 @@
               build/kern/process.o          \
               build/kern/chdev.o            \
+              build/kern/socket.o           \
               build/kern/cluster.o          \
               build/kern/scheduler.o        \
@@ -126,4 +127,5 @@
               build/libk/remote_condvar.o   \
               build/libk/remote_barrier.o   \
+              build/libk/remote_buf.o       \
               build/libk/memcpy.o           \
               build/libk/htab.o             \
@@ -192,5 +194,6 @@
               build/syscalls/sys_get_nb_cores.o    \
               build/syscalls/sys_get_thread_info.o \
-              build/syscalls/sys_fbf.o
+              build/syscalls/sys_fbf.o             \
+              build/syscalls/sys_socket.o
 
 VFS_OBJS    = build/fs/vfs.o              \
